/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.unterstuetzer.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.unterstuetzer.entity.Eintragungsliste;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class EintragungslisteExtendedDAO extends AbstractEintragungslisteDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: WahlvorschlagNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT obj FROM Eintragungsliste obj WHERE obj.wahlvorschlag = ?1<br>
* SQL: <br>
*/
@Override
public java.util.List<Eintragungsliste> findByWahlvorschlag( @javax.annotation.Nonnull de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag wahlvorschlag) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Eintragungsliste.findByWahlvorschlag" ,  wahlvorschlag  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahlvorschlag(): Miss");
        }

        cache.put(key, super.findByWahlvorschlag( wahlvorschlag  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahlvorschlag(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Eintragungsliste>) cache.lookup(key));
    }

    return super.findByWahlvorschlag( wahlvorschlag  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
